import unittest
import cadquery as Cq
import nhf.touhou.houjuu_nue as M

class Test(unittest.TestCase):

    def test_hs_joint_parent(self):
        p = M.Parameters()
        obj = p.hs_joint_parent()
        self.assertIsInstance(obj.val().solids(), Cq.Solid, msg="H-S joint must be in one piece")
    def test_wing_root(self):
        p = M.Parameters()
        obj = p.wing_root()
        #self.assertIsInstance(obj.solids(), Cq.Solid, msg="Wing root must be in one piece")
        bbox = obj.val().BoundingBox()

        msg = "Must fix 256^3 bbox"
        self.assertLess(bbox.xlen, 255, msg=msg)
        self.assertLess(bbox.ylen, 255, msg=msg)
        self.assertLess(bbox.zlen, 255, msg=msg)
    def test_wings(self):
        p = M.Parameters()
        p.wing_root()
    def test_harness(self):
        p = M.Parameters()
        p.harness_assembly()
    def test_trident(self):
        p = M.Parameters()
        assembly = p.trident_assembly()
        bbox = assembly.toCompound().BoundingBox()
        length = bbox.zlen
        self.assertGreater(length, 1300)
        self.assertLess(length, 1700)

if __name__ == '__main__':
    unittest.main()
